// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI64SSC750K/include/18ai64ssc750k_utils.h $
// $Rev: 53320 $
// $Date: 2023-07-05 16:05:29 -0500 (Wed, 05 Jul 2023) $

// 18AI64SSC750K: Utilities: header file

#ifndef	__18AI64SSC750K_UTILS_H__
#define	__18AI64SSC750K_UTILS_H__

#include "18ai64ssc750k_api.h"
#include "gsc_utils.h"
#include "gsc_utils_pci.h"



// prototypes *****************************************************************

// API utility services

int	ai64ssc750k_close_util			(int fd, int index, int verbose);
int ai64ssc750k_init_util			(int verbose);
int ai64ssc750k_ioctl_util			(int fd, int index, int verbose, int request, void* arg);
int	ai64ssc750k_open_util			(int device, int share, int index, int verbose, int* fd);
int	ai64ssc750k_read_util			(int fd, int index, int verbose, void* dst, size_t bytes, size_t* got);

// IOCTL utility services

int	ai64ssc750k_ai_63_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_AI_63_MODE
int	ai64ssc750k_ai_buf_clear		(int fd, int index, int verbose);								// AI64SSC750K_IOCTL_AI_BUF_CLEAR
int	ai64ssc750k_ai_buf_level		(int fd, int index, int verbose, s32* get);						// AI64SSC750K_IOCTL_AI_BUF_LEVEL
int	ai64ssc750k_ai_buf_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_AI_BUF_OVERFLOW
int	ai64ssc750k_ai_buf_thr_lvl		(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_AI_BUF_THR_LVL
int	ai64ssc750k_ai_buf_thr_sts		(int fd, int index, int verbose, s32* get);						// AI64SSC750K_IOCTL_AI_BUF_THR_STS
int	ai64ssc750k_ai_buf_underflow	(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_AI_BUF_UNDERFLOW
int	ai64ssc750k_ai_mode				(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_AI_MODE
int	ai64ssc750k_ai_range			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_AI_RANGE
int	ai64ssc750k_autocal				(int fd, int index, int verbose);								// AI64SSC750K_IOCTL_AUTOCAL
int	ai64ssc750k_autocal_status		(int fd, int index, int verbose, s32* get);						// AI64SSC750K_IOCTL_AUTOCAL_STATUS
int	ai64ssc750k_aux_clk_ctrl		(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_AUX_CLK_CTRL
int	ai64ssc750k_aux_in_pol			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_AUX_IN_POL
int	ai64ssc750k_aux_noise			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_AUX_NOISE
int	ai64ssc750k_aux_out_pol			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_AUX_OUT_POL
int	ai64ssc750k_aux_trig_ctrl		(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_AUX_TRIG_CTRL
int	ai64ssc750k_burst_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_BURST_ENABLE
int	ai64ssc750k_burst_size			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_BURST_SIZE
int	ai64ssc750k_burst_src			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_BURST_SRC
int	ai64ssc750k_burst_status		(int fd, int index, int verbose, s32* get);						// AI64SSC750K_IOCTL_BURST_STATUS
int	ai64ssc750k_burst_trig			(int fd, int index, int verbose);								// AI64SSC750K_IOCTL_BURST_TRIG
int	ai64ssc750k_chan_active			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_CHAN_ACTIVE
int	ai64ssc750k_chan_first			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_CHAN_FIRST
int	ai64ssc750k_chan_last			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_CHAN_LAST
int	ai64ssc750k_chan_single			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_CHAN_SINGLE
int	ai64ssc750k_clock_out			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_CLOCK_OUT
int	ai64ssc750k_clocking_enable		(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_CLOCKING_ENABLE
int	ai64ssc750k_data_format			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_DATA_FORMAT
int	ai64ssc750k_data_packing		(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_DATA_PACKING
int	ai64ssc750k_data_width			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_DATA_WIDTH
int	ai64ssc750k_initialize			(int fd, int index, int verbose);								// AI64SSC750K_IOCTL_INITIALIZE
int	ai64ssc750k_input_clock			(int fd, int index, int verbose);								// AI64SSC750K_IOCTL_INPUT_CLOCK
int	ai64ssc750k_irq0_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_IRQ0_SEL
int	ai64ssc750k_irq1_sel			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_IRQ1_SEL
int	ai64ssc750k_low_lat_doh			(int fd, int index, int verbose, s32* get);						// AI64SSC750K_IOCTL_LOW_LAT_DOH
int	ai64ssc750k_low_lat_read		(int fd, int index, int verbose, ai64ssc750k_ll_t* get);		// AI64SSC750K_IOCTL_LOW_LAT_READ
int	ai64ssc750k_query				(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_QUERY
int	ai64ssc750k_rag_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_RAG_ENABLE
int	ai64ssc750k_rag_nrate			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_RAG_NRATE
int	ai64ssc750k_rbg_clk_src			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_RBG_CLK_SRC
int	ai64ssc750k_rbg_enable			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_RBG_ENABLE
int	ai64ssc750k_rbg_nrate			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_RBG_NRATE
int	ai64ssc750k_reg_mod				(int fd, int index, int verbose, u32 reg, u32 value, u32 mask);	// AI64SSC750K_IOCTL_REG_MOD
int	ai64ssc750k_reg_read			(int fd, int index, int verbose, u32 reg, u32* value);			// AI64SSC750K_IOCTL_REG_READ
int	ai64ssc750k_reg_write			(int fd, int index, int verbose, u32 reg, u32 value);			// AI64SSC750K_IOCTL_REG_WRITE
int	ai64ssc750k_rx_io_abort			(int fd, int index, int verbose, s32* get);						// AI64SSC750K_IOCTL_RX_IO_ABORT
int	ai64ssc750k_rx_io_mode			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_RX_IO_MODE
int	ai64ssc750k_rx_io_overflow		(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_RX_IO_OVERFLOW
int	ai64ssc750k_rx_io_timeout		(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_RX_IO_TIMEOUT
int	ai64ssc750k_rx_io_underflow		(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_RX_IO_UNDERFLOW
int	ai64ssc750k_samp_clk_src		(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_SAMP_CLK_SRC
int	ai64ssc750k_scan_marker			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_SCAN_MARKER
int	ai64ssc750k_scan_marker_get		(int fd, int index, int verbose, u32* get);						// AI64SSC750K_IOCTL_SCAN_MARKER_GET
int	ai64ssc750k_scan_marker_set		(int fd, int index, int verbose, u32 set);						// AI64SSC750K_IOCTL_SCAN_MARKER_SET
int	ai64ssc750k_trigger_out			(int fd, int index, int verbose, s32 set, s32* get);			// AI64SSC750K_IOCTL_TRIGGER_OUT
int	ai64ssc750k_wait_cancel			(int fd, int index, int verbose, gsc_wait_t* wait);				// AI64SSC750K_IOCTL_WAIT_CANCEL
int	ai64ssc750k_wait_event			(int fd, int index, int verbose, gsc_wait_t* wait);				// AI64SSC750K_IOCTL_WAIT_EVENT
int	ai64ssc750k_wait_status			(int fd, int index, int verbose, gsc_wait_t* wait);				// AI64SSC750K_IOCTL_WAIT_STATUS

// Auxiliary utility services

int	ai64ssc750k_config_ai			(int fd, int index, int verbose, s32 fsamp);
int	ai64ssc750k_config_aux			(int fd, int index, int verbose);
int	ai64ssc750k_fsamp_ai_compute	(int fd, int index, int verbose, s32 fsamp, s32* src, s32* src_b, s32* nrate_a, s32* nrate_b, s32* enable_a, s32* enable_b, double* rate);
int ai64ssc750k_fsamp_ai_report		(int fd, int index, int verbose, int chan, s32* fsamp);
int ai64ssc750k_fsamp_ai_report_all	(int fd, int index, int verbose, s32* fsamp);
int	ai64ssc750k_id_device			(int fd, int index, int verbose);

int	ai64ssc750k_count_boards		(int verbose, s32* get);
int	ai64ssc750k_reg_list			(int fd, int detail);

const gsc_reg_def_t*				ai64ssc750k_reg_get_def_id(u32 reg);
const gsc_reg_def_t*				ai64ssc750k_reg_get_def_index(int index);
const char*							ai64ssc750k_reg_get_desc(u32 reg);
const char*							ai64ssc750k_reg_get_name(u32 reg);



#endif
