// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI64SSC750K/samples/irq/irq_1.c $
// $Rev: 43009 $
// $Date: 2018-06-22 17:29:20 -0500 (Fri, 22 Jun 2018) $

// 18AI64SSC750K: Sample Application: source file

#include "main.h"



//*****************************************************************************
static int _low_2_high(int fd)
{
	int	errs	= 0;

	errs	+= ai64ssc750k_initialize		(fd, -1, 0);
	errs	+= ai64ssc750k_ai_buf_thr_lvl	(fd, -1, 0, 16, NULL);
	errs	+= ai64ssc750k_rag_enable		(fd, -1, 0, AI64SSC750K_GEN_ENABLE_YES, NULL);
	errs	+= ai64ssc750k_irq1_sel			(fd, -1, 0, AI64SSC750K_IRQ1_IN_BUF_THR_L2H, NULL);
	errs	+= ai64ssc750k_clocking_enable	(fd, -1, 0, AI64SSC750K_CLOCKING_ENABLE_YES, NULL);
	os_sleep_ms(1000);
	return(errs);
}



//*****************************************************************************
static int _irq1_in_buf_thr_l2h_test(int fd)
{
	int	errs;

	gsc_label("Buffer Threshold Low-to-High");
	errs	= irq_wait_test(fd, 0, AI64SSC750K_WAIT_GSC_IN_BUF_THR_L2H, 0, _low_2_high);
	return(errs);
}



//*****************************************************************************
static int _high_2_low(int fd)
{
	int	errs	= 0;

	errs	+= ai64ssc750k_initialize		(fd, -1, 0);
	errs	+= ai64ssc750k_ai_buf_thr_lvl	(fd, -1, 0, 16, NULL);
	errs	+= ai64ssc750k_irq1_sel			(fd, -1, 0, AI64SSC750K_IRQ1_IN_BUF_THR_H2L, NULL);
	errs	+= ai64ssc750k_rag_enable		(fd, -1, 0, AI64SSC750K_GEN_ENABLE_YES, NULL);
	errs	+= ai64ssc750k_clocking_enable	(fd, -1, 0, AI64SSC750K_CLOCKING_ENABLE_YES, NULL);
	os_sleep_ms(1000);
	errs	+= ai64ssc750k_clocking_enable	(fd, -1, 0, AI64SSC750K_CLOCKING_ENABLE_NO, NULL);
	errs	+= ai64ssc750k_ai_buf_clear		(fd, -1, 0);
	return(errs);
}



//*****************************************************************************
static int _irq1_in_buf_thr_h2l_test(int fd)
{
	int	errs;

	gsc_label("Buffer Threshold High-to-Low");
	errs	= irq_wait_test(fd, 0, AI64SSC750K_WAIT_GSC_IN_BUF_THR_H2L, 0, _high_2_low);
	return(errs);
}



//*****************************************************************************
static int _error_overflow(int fd)
{
	int	errs	= 0;

	errs	+= ai64ssc750k_initialize		(fd, -1, 0);
	errs	+= ai64ssc750k_irq1_sel			(fd, -1, 0, AI64SSC750K_IRQ1_BUF_ERROR, NULL);
	errs	+= ai64ssc750k_rag_enable		(fd, -1, 0, AI64SSC750K_GEN_ENABLE_YES, NULL);
	errs	+= ai64ssc750k_clocking_enable	(fd, -1, 0, AI64SSC750K_CLOCKING_ENABLE_YES, NULL);
	os_sleep_ms(1000);
	return(errs);
}



//*****************************************************************************
static int _error_underflow(int fd)
{
	int	errs	= 0;
	u32	idbr;

	errs	+= ai64ssc750k_initialize	(fd, -1, 0);
	errs	+= ai64ssc750k_irq1_sel		(fd, -1, 0, AI64SSC750K_IRQ1_BUF_ERROR, NULL);
	errs	+= ai64ssc750k_reg_read		(fd, -1, 0, AI64SSC750K_GSC_IDBR, &idbr);
	return(errs);
}



//*****************************************************************************
static int _irq1_in_buf_error_test(int fd)
{
	int	errs	= 0;

	gsc_label("Buffer Error");
	printf("\n");
	gsc_label_level_inc();

	gsc_label("Overflow");
	errs	+= irq_wait_test(fd, 0, AI64SSC750K_WAIT_GSC_BUF_ERROR, 0, _error_overflow);

	gsc_label("Underflow");
	errs	+= irq_wait_test(fd, 0, AI64SSC750K_WAIT_GSC_BUF_ERROR, 0, _error_underflow);

	gsc_label_level_dec();
	return(errs);
}



//*****************************************************************************
int irq_1_test(int fd)
{
	int	errs	= 0;

	gsc_label("IRQ1");
	printf("\n");
	gsc_label_level_inc();

	errs	+= _irq1_in_buf_thr_l2h_test(fd);
	errs	+= _irq1_in_buf_thr_h2l_test(fd);
	errs	+= _irq1_in_buf_error_test(fd);

	gsc_label_level_dec();
	return(errs);
}


