// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI64SSC750K/samples/savedata/main.h $
// $Rev: 53328 $
// $Date: 2023-07-05 16:15:16 -0500 (Wed, 05 Jul 2023) $

// 18AI64SSC750K: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "18ai64ssc750k_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	chan_tag;		// exclude the channel tag from saved data
	s32	decimal;		// Save data in decimal format? Default is hex.
	s32	force_save;		// Save data even if there are errors?
	s32	fsamp;			// Desired sample rate.
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	repeat;			// repeat data retrieval this many times
	s32	tag_strip;		// Strip the channel tag from the saved data?
	s32	test_limit;		// for continuous testing

	int	fd;				// File descriptor for device to access.

	// Device Settings

	s32	ai_mode;		// Analog Input Mode
	s32	bursting;		// Burst Enable?
	s32	chan_active;	// Active Channel: 0-1, ..., single, range
	s32	chan_first;		// First channel of channel range.
	s32	chan_last;		// Last channel of channel range.
	s32	chan_single;	// Single channel selection.
	s32	data_format;	// Offset Binary or Twos Compliment.
	s32	data_pack;		// Use data packing?
	s32	data_width;		// 16-bit vs 18-bits
	s32	io_mode;
	s32	scan_mark;		// The scan market value.
	s32	scan_marker;	// Include the scan marker?
	s32	v_range;		// Select this voltage range.
} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args);



#endif
