// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI64SSC750K/samples/signals/perform.c $
// $Rev: 53329 $
// $Date: 2023-07-05 16:15:31 -0500 (Wed, 05 Jul 2023) $

// 18AI64SSC750K: Sample Application: source file

#include "main.h"



//*****************************************************************************
int perform_tests(const args_t* args)
{
	char	buf[64];
	int		errs	= 0;
	s32		fref;
	s32		nrate;
	s32		sps;

	errs	+= ai64ssc750k_initialize(args->fd, -1, 0);
	errs	+= ai64ssc750k_query(args->fd, -1, 0, AI64SSC750K_QUERY_MASTER_CLOCK, &fref);

	//===============================================================
	gsc_label("Clock Output");
	printf("\n");
	gsc_label_level_inc();

	errs	+= ai64ssc750k_samp_clk_src		(args->fd, -1, 1, AI64SSC750K_SAMP_CLK_SRC_RAG,		NULL);
	nrate	= fref / 10000;
	errs	+= ai64ssc750k_rag_nrate		(args->fd, -1, 1, nrate,							NULL);
	errs	+= ai64ssc750k_rag_enable		(args->fd, -1, 1, AI64SSC750K_GEN_ENABLE_YES,		NULL);
	errs	+= ai64ssc750k_clocking_enable	(args->fd, -1, 1, AI64SSC750K_CLOCKING_ENABLE_YES,	NULL);
	errs	+= ai64ssc750k_ai_63_mode		(args->fd, -1, 1, AI64SSC750K_AI_63_MODE_TTL_CLK,	NULL);
	errs	+= ai64ssc750k_clock_out		(args->fd, -1, 1, AI64SSC750K_CLOCK_OUT_ENABLE,		NULL);
	errs	+= ai64ssc750k_fsamp_ai_report	(args->fd, -1, 1, -1, &sps);

	gsc_label_level_dec();

	//===============================================================
	gsc_label("Trigger Output");
	printf("\n");
	gsc_label_level_inc();

	errs	+= ai64ssc750k_burst_src		(args->fd, -1, 1, AI64SSC750K_BURST_SRC_RBG,		NULL);
	errs	+= ai64ssc750k_burst_size		(args->fd, -1, 1, 1,								NULL);
	nrate	= nrate * 3;
	errs	+= ai64ssc750k_rbg_nrate		(args->fd, -1, 1, nrate,							NULL);
	errs	+= ai64ssc750k_rbg_enable		(args->fd, -1, 1, AI64SSC750K_GEN_ENABLE_YES,		NULL);
	errs	+= ai64ssc750k_burst_enable		(args->fd, -1, 1, AI64SSC750K_BURST_ENABLE_YES,		NULL);
	errs	+= ai64ssc750k_trigger_out		(args->fd, -1, 1, AI64SSC750K_TRIGGER_OUT_ENABLE,	NULL);

	gsc_label_level_dec();

	//===============================================================
	gsc_label("Auxiliary Outputs");
	printf("\n");
	gsc_label_level_inc();

	errs	+= ai64ssc750k_aux_noise		(args->fd, -1, 1, AI64SSC750K_AUX_NOISE_HIGH,			NULL);
	errs	+= ai64ssc750k_aux_clk_ctrl		(args->fd, -1, 1, AI64SSC750K_AUX_CLK_CTRL_OUTPUT,	NULL);
	errs	+= ai64ssc750k_aux_trig_ctrl	(args->fd, -1, 1, AI64SSC750K_AUX_TRIG_CTRL_OUTPUT,	NULL);

	gsc_label_level_dec();

	//===============================================================
	sprintf(buf, "Waiting (%ld sec%s)", (long) args->seconds, (args->seconds == 1) ? "" : "s");
	gsc_label(buf);
	fflush(stdout);
	os_sleep_ms(args->seconds * 1000);
	printf("Done\n");

	errs	+= ai64ssc750k_initialize(args->fd, -1, 0);

	return(errs);
}



