// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI64SSC750K/samples/vrange/main.h $
// $Rev: 53330 $
// $Date: 2023-07-05 16:15:46 -0500 (Wed, 05 Jul 2023) $

// 18AI64SSC750K: Sample Application: header file

#ifndef	__MAIN_H__
#define	__MAIN_H__

#include <ctype.h>
#include <errno.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <sys/time.h>

#include "18ai64ssc750k_main.h"



// macros *********************************************************************

#define	SIZEOF_ARRAY(a)			(sizeof((a)) / sizeof((a)[0]))



// data types *****************************************************************

typedef struct
{
	// Application Settings

	s32	ai_chan;
	s32	ai_mode;		// Select ONLY Analog Input Mode: xxx
	s32	ai_voltage;		// Select ONLY Analog Input Voltage Range: xxx
	s32	ascii_graph;	// Produce an ASCII graph of the data # wide.
	s32	continuous;		// > 0 = ignore errors, < 0 = stop on errors
	s32	detail;
	s32	index;			// device index
	s32	minute_limit;	// for continuous testing
	int	qty;			// Number of devices detected.
	s32	reg_list;		// Include a register list after processing configuration.
	s32	save;			// Save data to vrange.txt.
	s32	test_limit;		// for continuous testing
	s32	verbose;		// Enable verbose output.

	int	fd;				// File descriptor for device to access.

	// Device Settings

} args_t;



// prototypes *****************************************************************

int	perform_tests(const args_t* args);



#endif
