// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI64SSC750K/utils/util_burst_size.c $
// $Rev: 53322 $
// $Date: 2023-07-05 16:08:44 -0500 (Wed, 05 Jul 2023) $

// 18AI64SSC750K: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai64ssc750k_burst_size
*
*	Purpose:
*
*		Provide a visual wrapper for the AI64SSC750K_IOCTL_BURST_SIZE service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int ai64ssc750k_burst_size(int fd, int index, int verbose, s32 set, s32* get)
{
	int			errs;
	const char*	ptr		= "";
	int			ret;

	if (verbose)
		gsc_label_index("Burst Size", index);

	ret		= ai64ssc750k_ioctl(fd, AI64SSC750K_IOCTL_BURST_SIZE, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
	{
		if (set == -1)
			ptr	= ", This service is not supported by this device.";

		printf("%s  (", errs ? "FAIL <---" : "PASS");
		gsc_label_long_comma(set);
		printf(" scan%s%s)\n", (set == 1) ? "" : "s", ptr);
	}

	if (get)
		get[0]	= set;

	return(errs);
}


