// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI64SSC750K/utils/util_config_aux.c $
// $Rev: 53322 $
// $Date: 2023-07-05 16:08:44 -0500 (Wed, 05 Jul 2023) $

// 18AI64SSC750K: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai64ssc750k_config_aux
*
*	Purpose:
*
*		Configure the Auxiliary services.
*
*	Arguments:
*
*		fd		The handle to use to access the driver.
*
*		index	The index of the device to access. Ignore if < 0.
*
*		verbose	Work verbosely?
*
*		set		The setting to apply.
*
*		get		The current setting is recorded here, if not NULL.
*
*	Returned:
*
*		>= 0	The number of errors encountered here.
*
******************************************************************************/

int	ai64ssc750k_config_aux(int fd, int index, int verbose)
{
	int	errs	= 0;

	if (verbose)
	{
		gsc_label_index("Auxiliary Configuration", index);
		printf("\n");
		gsc_label_level_inc();
	}

	// Settings must be applied after the initialization call!

	errs	+= ai64ssc750k_aux_in_pol	(fd, index, verbose, AI64SSC750K_AUX_IN_CTRL_L2H,		NULL);
	errs	+= ai64ssc750k_aux_noise	(fd, index, verbose, AI64SSC750K_AUX_NOISE_HIGH,		NULL);
	errs	+= ai64ssc750k_aux_out_pol	(fd, index, verbose, AI64SSC750K_AUX_OUT_POL_HIGH,		NULL);
	errs	+= ai64ssc750k_aux_clk_ctrl	(fd, index, verbose, AI64SSC750K_AUX_CLK_CTRL_OUTPUT,	NULL);
	errs	+= ai64ssc750k_aux_trig_ctrl(fd, index, verbose, AI64SSC750K_AUX_TRIG_CTRL_OUTPUT,	NULL);

	if (verbose)
		gsc_label_level_dec();

	return(errs);
}


