// $URL: http://subversion:8080/svn/gsc/trunk/drivers/LINUX/18AI64SSC750K/utils/util_low_lat_read.c $
// $Rev: 53322 $
// $Date: 2023-07-05 16:08:44 -0500 (Wed, 05 Jul 2023) $

// 18AI64SSC750K: Utilities: source file

#include "main.h"



/******************************************************************************
*
*	Function:	ai64ssc750k_low_lat_read
*
*	Purpose:
*
*		Provide a visual wrapper for the AI64SSC750K_IOCTL_LOW_LAT_READ service.
*
*	Arguments:
*
*		fd		Use this handle to access the device.
*
*		index	The index of the device to access. Ignore if < 0.
*				This is for display purposes only.
*
*		verbose	Work verbosely?
*
*		get		The data retrieved goes here.
*
*	Returned:
*
*		>= 0	The number of errors encounterred.
*
******************************************************************************/

int	ai64ssc750k_low_lat_read(int fd, int index, int verbose, ai64ssc750k_ll_t* get)
{
	int					errs;
	int					ret;
	ai64ssc750k_ll_t	set;

	if (verbose)
		gsc_label_index("LL Read", index);

	ret		= ai64ssc750k_ioctl(fd, AI64SSC750K_IOCTL_LOW_LAT_READ, &set);
	errs	= ret ? 1 : 0;

	if (verbose)
		printf("%s\n", errs ? "FAIL <---" : "PASS");

	if (get)
		get[0]	= set;

	return(errs);
}


